Subject: bug#39799: 28.0.50; Most emoji sequences don’t render correctly

From: Eli Zaretskii <[email-masked]>
Date: Fri, 28 Feb 2020 10:25:22 +0200

> From: Mike FABIAN <[email-masked]>
> Cc: [email-masked]
> Date: Fri, 28 Feb 2020 08:36:10 +0100
> 
> > Patches are welcome to convert the emoji-related files in Unicode's
> > character database into appropriate composition-function-table setup,
> > similar to the example above.  Some script to be run at Emacs build
> > time and produce, say, lisp/emoji.el to populate
> > composition-function-table, would be nice (see the Awk scripts in
> > admin/unidata as one source of inspiration).
> 
> Pango also has a .c file which is generated by a python script from
> the Unicode emoji data files to make all these sequences known to Pango.
> 
> I can try to write a script. Would it be OK to use Python for such a
> script generating emoji.el?

I'd prefer not to add Python as prerequisite for building Emacs.  We
already use Awk, so using that'd be fine.

Alternatively, we could do it in Emacs Lisp, similar to
unidata-gen.el, but that requires some care because we cannot run Lisp
programs until we have some version of Emacs.

> > If you mean they are not displayed in correct colors, then Emacs
> > doesn't yet support color emoji, we lack some infrastructure for
> > that.  Again, work in that area is welcome, it should be relatively
> > easy since we now have HarfBuzz support for text shaping.
> 
> Actually the color display works already. I tested with current master
> (build with cairo) and the emoji display just fine in color.

Maybe in a Cairo build.  Or maybe I'm missing something.